<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>UpgradeMain.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.upgrade</a> &gt; <span class="el_source">UpgradeMain.java</span></div><h1>UpgradeMain.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.upgrade;

import java.io.File;
import java.io.IOException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.server.DataTree;
import org.apache.zookeeper.server.persistence.FileTxnSnapLog;

/**
 * This class upgrades the older database 
 * to a new database for the zookeeper 
 * servers.
 * The way to run it is 
 * java -class path zookeeper.jar Upgrade dataDir snapShotDir
 * or using zookeeper scripts with zkServer -upgrade dataDir snapShotDir 
 * it creates a backup in the dataDir/.bkup and snapShotDir/.bkup which 
 * can be retrieved back to the snapShotDir and dataDir 
 */
public class UpgradeMain {
    File snapShotDir;
    File dataDir;
    File bkupsnapShotDir;
    File bkupdataDir;
    File currentdataDir;
    File currentsnapShotDir;
    
<span class="fc" id="L47">    private static final Logger LOG = LoggerFactory.getLogger(UpgradeMain.class);</span>
    private static final String USAGE = &quot;Usage: UpgradeMain dataDir snapShotDir&quot;;
    private static final int LASTVERSION = 1;
    private static final int CURRENTVERSION = FileTxnSnapLog.VERSION;
    private static final String dirName = FileTxnSnapLog.version;
    private static final String manual = &quot;Please take manual steps to &quot; +
    		&quot;sanitize your database.\n Please read the upgrade manual&quot;;
    
     /**
     * upgrade class that takes the two file 
     * directories.
     * @param dataDir the directory that contains the 
     * transaction logs
     * @param snapShotDir the directory that contains 
     * the snapshots 
     */
<span class="fc" id="L63">    public UpgradeMain(File dataDir, File snapShotDir) {</span>
<span class="fc" id="L64">        this.snapShotDir = snapShotDir; </span>
<span class="fc" id="L65">        this.dataDir = dataDir;</span>
<span class="fc" id="L66">        this.bkupdataDir = new File(dataDir, dirName + LASTVERSION);</span>
<span class="fc" id="L67">        this.bkupsnapShotDir = new File(snapShotDir, dirName + LASTVERSION );</span>
<span class="fc" id="L68">        this.currentsnapShotDir = new File(snapShotDir, dirName + CURRENTVERSION);</span>
<span class="fc" id="L69">        this.currentdataDir = new File(dataDir, dirName + CURRENTVERSION);</span>
<span class="fc" id="L70">    }</span>
 
    /**
     * create all the bkup directories and the current
     * database directories
     * @throws IOException
     */
    private void createAllDirs() throws IOException {
<span class="fc" id="L78">        String error = &quot;backup directory &quot; + bkupdataDir + &quot; already exists&quot;;</span>
<span class="fc" id="L79">        LOG.info(&quot;Creating previous version data dir &quot; + bkupdataDir);</span>
<span class="pc bpc" id="L80" title="1 of 2 branches missed.">        if (!bkupdataDir.mkdirs()) {</span>
<span class="nc" id="L81">            LOG.error(error);</span>
<span class="nc" id="L82">            LOG.error(manual);</span>
<span class="nc" id="L83">            throw new IOException(error);</span>
        }
<span class="fc" id="L85">        LOG.info(&quot;Creating previous version snapshot dir &quot; + bkupdataDir);</span>
<span class="pc bpc" id="L86" title="2 of 4 branches missed.">        if (!bkupsnapShotDir.mkdirs() &amp;&amp; !bkupsnapShotDir.exists()) {</span>
<span class="nc" id="L87">            LOG.error(error);</span>
<span class="nc" id="L88">            LOG.error(manual);</span>
<span class="nc" id="L89">            throw new IOException(error);</span>
        }
<span class="fc" id="L91">        error = &quot;current directory &quot; + currentdataDir + &quot; already exists&quot;;</span>
<span class="fc" id="L92">        LOG.info(&quot;Creating current data dir &quot; + currentdataDir);</span>
<span class="pc bpc" id="L93" title="1 of 2 branches missed.">        if (!currentdataDir.mkdirs()) {</span>
<span class="nc" id="L94">            LOG.error(error);</span>
<span class="nc" id="L95">            LOG.error(manual);</span>
<span class="nc" id="L96">            throw new IOException(error);</span>
        }
<span class="fc" id="L98">        LOG.info(&quot;Creating current snapshot dir &quot; + currentdataDir);</span>
<span class="pc bpc" id="L99" title="2 of 4 branches missed.">        if (!currentsnapShotDir.mkdirs() &amp;&amp; !currentsnapShotDir.exists()) {</span>
<span class="nc" id="L100">            LOG.error(error);</span>
<span class="nc" id="L101">            LOG.error(manual);</span>
<span class="nc" id="L102">            throw new IOException(error);</span>
        }
<span class="fc" id="L104">    }</span>
    
    /**
     * copy files from srcdir to dstdir that have the string 
     * filter in the srcdir filenames
     * @param srcDir the source directory
     * @param dstDir the destination directory
     * @param filter the filter of filenames that 
     * need to be copied.
     * @throws IOException
     */
    void copyFiles(File srcDir, File dstDir, String filter) throws IOException {
<span class="fc" id="L116">        File[] list = srcDir.listFiles();</span>
<span class="fc bfc" id="L117" title="All 2 branches covered.">        for (File file: list) {</span>
<span class="fc" id="L118">            String name = file.getName();</span>
<span class="fc bfc" id="L119" title="All 2 branches covered.">            if (name.startsWith(filter)) {</span>
                // we need to copy this file
<span class="fc" id="L121">                File dest = new File(dstDir, name);</span>
<span class="fc" id="L122">                LOG.info(&quot;Renaming &quot; + file + &quot; to &quot; + dest);</span>
<span class="pc bpc" id="L123" title="1 of 2 branches missed.">                if (!file.renameTo(dest)) {</span>
<span class="nc" id="L124">                    throw new IOException(&quot;Unable to rename &quot; </span>
                            + file + &quot; to &quot; +  dest);
                }
            }
        }
<span class="fc" id="L129">    }</span>
    
    /**
     * run the upgrade
     * @throws IOException
     */
    public void runUpgrade() throws IOException {
<span class="pc bpc" id="L136" title="1 of 2 branches missed.">        if (!dataDir.exists()) {</span>
<span class="nc" id="L137">            throw new IOException(dataDir + &quot; does not exist&quot;);</span>
        }
<span class="pc bpc" id="L139" title="1 of 2 branches missed.">        if (!snapShotDir.exists()) {</span>
<span class="nc" id="L140">            throw new IOException(snapShotDir + &quot; does not exist&quot;);</span>
        }
        // create the bkup directorya
<span class="fc" id="L143">        createAllDirs();</span>
        //copy all the files for backup
        try {
<span class="fc" id="L146">            copyFiles(dataDir, bkupdataDir, &quot;log&quot;);</span>
<span class="fc" id="L147">            copyFiles(snapShotDir, bkupsnapShotDir, &quot;snapshot&quot;);</span>
<span class="nc" id="L148">        } catch(IOException io) {</span>
<span class="nc" id="L149">            LOG.error(&quot;Failed in backing up.&quot;);</span>
<span class="nc" id="L150">            throw io;</span>
<span class="fc" id="L151">        }</span>

        //evrything is backed up
        // read old database and create 
        // an old snapshot
<span class="fc" id="L156">        UpgradeSnapShotV1 upgrade = new UpgradeSnapShotV1(bkupdataDir, </span>
                bkupsnapShotDir);
<span class="fc" id="L158">        LOG.info(&quot;Creating new data tree&quot;);</span>
<span class="fc" id="L159">        DataTree dt = upgrade.getNewDataTree();</span>
<span class="fc" id="L160">        FileTxnSnapLog filesnapLog = new FileTxnSnapLog(dataDir, </span>
                snapShotDir);
<span class="fc" id="L162">        LOG.info(&quot;snapshotting the new datatree&quot;);</span>
<span class="fc" id="L163">        filesnapLog.save(dt, upgrade.getSessionWithTimeOuts());</span>
        //done saving.
<span class="fc" id="L165">        LOG.info(&quot;Upgrade is complete&quot;);</span>
<span class="fc" id="L166">    }</span>
    
    public static void main(String[] argv) {
<span class="nc bnc" id="L169" title="All 2 branches missed.">        if (argv.length &lt; 2) {</span>
<span class="nc" id="L170">            LOG.error(USAGE);</span>
<span class="nc" id="L171">            System.exit(-1);</span>
        }
        try {
<span class="nc" id="L174">            UpgradeMain upgrade = new UpgradeMain(new File(argv[0]), new File(argv[1]));</span>
<span class="nc" id="L175">            upgrade.runUpgrade();</span>
<span class="nc" id="L176">        } catch(Throwable th) {</span>
<span class="nc" id="L177">            LOG.error(&quot;Upgrade Error: Please read the &quot; +</span>
            		&quot;docs for manual failure recovery &quot;, th);
<span class="nc" id="L179">        }</span>
<span class="nc" id="L180">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>